# This file is used to define the CI/CD Pipeline for Gitlab. If you do not use Gitlab, or do not want to automatically
# build the Processing-App, you can delete this file.

build:
  image: maven:latest
  stage: build
  script:
    - 'mvn clean install package -B'
    - 'mv target/**/target target/build'
  artifacts:
    expire_in: 30 days
    paths:
      - target/build
  only:
    - tags
    - main

bundle:
  image: alpine:latest
  stage: build
  script:
    # Bundle into ZIP
    - 'apk add zip'
    - 'apk add curl'
    - '(cd target/build && zip -r build.zip .)'
    - 'mv ./target/build/build.zip ./build.zip'
    - 'ls'
    - 'echo $CI_PROJECT_ID'
    # Send zip to Packages Repo
    - 'CURL_DIST=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/releases/${CI_COMMIT_TAG}/release.zip'
    - 'echo $CURL_DIST'
    - 'curl --header "JOB-TOKEN: $CI_JOB_TOKEN" --upload-file build.zip ${CURL_DIST}'
  needs:
      - job: build
        artifacts: true
  only:
    - tags


release:
  stage: deploy
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  needs:
    - job: bundle
      artifacts: false
  only:
    - tags
  script:
    - "echo 'Creating Release ${CI_COMMIT_TAG}'"
  release:
    tag_name: '$CI_COMMIT_TAG'
    description: '$CI_COMMIT_SHA'
    ref: '$CI_COMMIT_SHA'
    assets:
      links:
        - name: 'Release'
          url: '${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/generic/releases/${CI_COMMIT_TAG}/release.zip'



